package com.elitesland.org.param;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * @author mir
 */
@Data
@Accessors(chain = true)
@ApiModel("雇员创建和更新用的数据对象")
public class EmployeeSave implements Serializable {

    private static final long serialVersionUID = -8054976745915828476L;

    @ApiModelProperty("雇员记录ID")
    Long id;

    @ApiModelProperty(value = "雇员编号")
    String empNo;

    @ApiModelProperty(value = "雇员姓名")
    String name;

    @ApiModelProperty(value = "雇员外文名")
    String foreignName;

    @ApiModelProperty("所属公司ID")
    Long ouId;

    @ApiModelProperty(value = "所属部门ID")
    Long buId;

    @ApiModelProperty("岗位记录ID")
    Long postId;

    @ApiModelProperty(value = "行政职位, [UDC]ORG:TITLE")
    String title;

    @ApiModelProperty(value = "系统用户ID")
    Long sysUserId;

    @ApiModelProperty(value = "系统用户账号")
    String sysUserName;

    @ApiModelProperty("系统登录密码")
    String sysPassword;

    @ApiModelProperty(value = "工作邮箱")
    String email;

    @ApiModelProperty(value = "工作手机号")
    String mobile;

    @ApiModelProperty(value = "是否创建用户")
    Boolean needCreateUser;
}
